% CAMPIONAMENTO DEL PROFILO DI VELOCITÀ
% Posizioni (in cm)
x0 = [0.010, 0.054, 0.111, 0.138];
% Velocità (in m/s)
y0 = [1.40, 1.70, 1.54, 1.33];
% Estremi della condotta
x_l = 0;
x_u = 0.150;

function plot_approx(p, x_l, x_u, x0, y0)
	% "p" è il polinomio da disegnare
	% "x_l" e "x_u" sono gli estremi dell'intervallo da disegnare
	% "x0" e "y0" sono i punti campionati

	% Definisco il range per il disegno
	x = linspace(x_l, x_u);
	% Disegno il polinomio interpolante
	figure() % Apro una nuova figura
	hold on % Permetto di avere più di un plot sulla figura
	plot(x, polyval(p, x), 'k', 'linewidth', 1.5);
	% Disegno i punti originari
	scatter(x0, y0, 8, 'r', 'filled');
	hold off
	xlim([x_l, x_u]);
end

function p = my_polyfit1(x0, y0)
	p = polyfit(x0, y0, length(x0)-1);
end

function p = my_polyfit2(x0, y0)
	V = vander(x0);
	p = V \ y0';
end

p = my_polyfit1(x0, y0)
plot_approx(p, x_l, x_u, x0, y0)

p = my_polyfit2(x0, y0)
plot_approx(p, x_l, x_u, x0, y0)