% Leggo i dati da file
data = dlmread('ch11_es2.csv');
% Separo le x e le y
x0 = data(:, 1)';
y0 = data(:, 2)';
% Estremi dell'intervallo
x_l = 0;
x_u = 5;

function plot_approx(p, x_l, x_u, x0, y0)
	% "p" è il polinomio da disegnare
	% "x_l" e "x_u" sono gli estremi dell'intervallo da disegnare
	% "x" e "y" sono i punti campionati

	% Definisco il range per il disegno
	x = linspace(x_l, x_u);
	% Disegno il polinomio interpolante
	figure() % Apro una nuova figura
	hold on % Permetto di avere più di un plot sulla figura
	plot(x, polyval(p, x), 'k', 'linewidth', 1.5);
	% Disegno i punti originari
	scatter(x0, y0, 5, 'r', 'x');
	hold off
	xlim([x_l, x_u]);
end

function e = approx_error(p, x0, y0)
	e = sum((y0 - polyval(p, x0)).^2);
end

function p = my_polyfit1(x0, y0, n)
	p = polyfit(x0, y0, n);
end

function p = my_polyfit2(x0, y0, n)
	V = vander(x0, n+1);
	p = V \ y0';
end

% Definisco il grado del polinomio
n = 2;

p = my_polyfit1(x0, y0, n)
e = approx_error(p, x0, y0)
plot_approx(p, x_l, x_u, x0, y0)

p = my_polyfit2(x0, y0, n)
e = approx_error(p, x0, y0)
plot_approx(p, x_l, x_u, x0, y0)