% Leggo i dati da file
data = dlmread('ch11_es4.csv');
% Separo le x e le y
x0 = data(:, 1)';
y0 = data(:, 2)';
% Estremi dell'intervallo
x_l = 1;
x_u = 5;

function phi = build_phi_matrix(x0)
	phi = [x0.^0; 1./x0; 1./x0.^2; 1./x0.^3];
	phi = phi';
end

function plot_approx(p, x_l, x_u, x0, y0)
	% "p" sono i parametri della funzione approssimante
	% "x_l" e "x_u" sono gli estremi dell'intervallo da disegnare
	% "x" e "y" sono i punti campionati

	% Definisco il range per il disegno
	x = linspace(x_l, x_u);
	% Ottengo i valori della funzione approssimante
	phi = build_phi_matrix(x);
	y = phi * p; % prodotto scalare

	% Disegno il polinomio interpolante
	figure() % Apro una nuova figura
	hold on % Permetto di avere più di un plot sulla figura
	plot(x, y, 'k', 'linewidth', 1.5);
	% Disegno i punti originari
	scatter(x0, y0, 4, 'r', 'x');
	hold off
	xlim([x_l, x_u]);
end

phi = build_phi_matrix(x0);
p = phi \ y0'
r = y0' - phi * p;
e = sum(r.^2)
plot_approx(p, x_l, x_u, x0, y0)