% CAMPIONAMENTO DEL PROFILO DI VELOCITÀ
% Posizioni (in cm)
x0 = [0.010, 0.054, 0.111, 0.138];
% Velocità (in m/s)
y0 = [1.40, 1.70, 1.54, 1.33];
% Estremi della condotta
x_l = 0;
x_u = 0.150;

function z = l(x, ii, x0)
	z = 1;
	for jj = 1:length(x0)
		if jj ~= ii
			z = z .* (x - x0(jj)) ./ (x0(ii) - x0(jj));
		end
	end
end

function y = f(x, x0, y0)
	y = 0;
	for ii = 1:length(x0)
		y = y + y0(ii) .* l(x, ii, x0);
	end
end

% Definisco il range per il disegno
x = linspace(x_l, x_u);
% Disegno il polinomio interpolante
figure() % Apro una nuova figura
hold on % Permetto di avere più di un plot sulla figura
plot(x, f(x, x0, y0), 'k', 'linewidth', 1.5);
% Disegno i punti originari
scatter(x0, y0, 8, 'r', 'filled');
hold off
xlim([x_l, x_u]);